
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java集合框架List，Map，Set等全面介绍 / iVAN</title>

    <meta name="description" content="Java集合框架List，Map，Set等全面介绍 Java Collections Framework是Java提供的对集合进行定义,操作,和管理的包含一组接口,类的体系结构.   Java集合框架的基本接口/类层次结构: java.util.Collection [I]+--java.util.List [I]   +--java.util.ArrayList [C]   +--java.util.LinkedList [C]   +--java.util.Vector [C]      +--java.util.Stack [C]+--ja">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java集合框架List，Map，Set等全面介绍</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Java Collections Framework是Java提供的对集合进行定义，操作，和管理的包含一组接口，类的体系结构。</p>
<p> </p>
<p>Java集合框架的基本接口/类层次结构：</p>
<p>java.util.Collection [I]<br />+--java.util.List [I]<br />   +--java.util.ArrayList [C]<br />   +--java.util.LinkedList [C]<br />   +--java.util.Vector [C]<br />      +--java.util.Stack [C]<br />+--java.util.Set [I]<br />   +--java.util.HashSet [C]<br />   +--java.util.SortedSet [I]<br />      +--java.util.TreeSet [C]</p>
<p>java.util.Map [I]<br />+--java.util.SortedMap [I]<br />   +--java.util.TreeMap [C]<br />+--java.util.Hashtable [C]<br />+--java.util.HashMap [C]<br />+--java.util.LinkedHashMap [C]<br />+--java.util.WeakHashMap [C]</p>
<p> </p>
<p>[I]：接口</p>
<p>[C]：类</p>
<p> </p>
<p><strong>Collection接口</strong><br />    Collection是最基本的集合接口，一个Collection代表一组Object的集合，这些Object被称作Collection的元素。</p>
<p>    所有实现Collection接口的类都必须提供两个标准的构造函数：无参数的构造函数用于创建一个空的Collection，有一个Collection参数的构造函数用于创建一个新的Collection，这 个新的Collection与传入的Collection有相同的元素。后一个构造函数允许用户复制一个Collection。<br />
<br />    如何遍历Collection中的每一个元素？不论Collection的实际类型如何，它都支持一个iterator()的方法，该方法返回一个迭代子，使用该迭代子即可逐一访问Collection中每一个元素。典型的用法如下：</p>
<ol>
<li>Iterator it = collection.iterator(); // 获得一个迭代子 </li>
<li>while(it.hasNext()) { </li>
<li>　　Object obj = it.next(); // 得到下一个元素 </li>
<li>} </li>
</ol>
<p>    根据用途的不同，Collection又划分为List与Set。</p>
<p> </p>
<p><strong>List接口</strong></p>
<p>    List继承自Collection接口。List是有序的Collection，使用此接口能够精确的控制每个元素插入的位置。用户能够使用索引（元素在List中的位置，类似于数组下标）来访问List中的元素，这类似于Java的数组。</p>
<p>    跟Set集合不同的是，List允许有重复元素。对于满足e1.equals(e2)条件的e1与e2对象元素，可以同时存在于List集合中。当然，也有List的实现类不允许重复元素的存在。</p>
<p>    除了具有Collection接口必备的iterator()方法外，List还提供一个listIterator()方法，返回一个 ListIterator接口，和标准的Iterator接口相比，ListIterator多了一些add()之类的方法，允许添加，删除，设定元素， 还能向前或向后遍历。</p>
<p>    实现List接口的常用类有LinkedList，ArrayList，Vector和Stack。</p>
<p> </p>
<p><strong>LinkedList类</strong></p>
<p>    LinkedList实现了List接口，允许null元素。此外LinkedList提供额外的get，remove，insert方法在 LinkedList的首部或尾部。这些操作使LinkedList可被用作堆栈（stack），队列（queue）或双向队列（deque）。</p>
<p>    注意LinkedList没有同步方法。如果多个线程同时访问一个List，则必须自己实现访问同步。一种解决方法是在创建List时构造一个同步的List：</p>
<ol>
<li>List list = Collections.synchronizedList(new LinkedList(...)); </li>
</ol>
<p> </p>
<p><strong>ArrayList类</strong></p>
<p>    ArrayList实现了可变大小的数组。它允许所有元素，包括null。ArrayList没有同步。</p>
<p>size，isEmpty，get，set方法运行时间为常数。但是add方法开销为分摊的常数，添加n个元素需要O(n)的时间。其他的方法运行时间为线性。</p>
<p>    每个ArrayList实例都有一个容量（Capacity），即用于存储元素的数组的大小。这个容量可随着不断添加新元素而自动增加，但是增长算法并 没有定义。当需要插入大量元素时，在插入前可以调用ensureCapacity方法来增加ArrayList的容量以提高插入效率。</p>
<p>    和LinkedList一样，ArrayList也是非同步的（unsynchronized）。</p>
<p> </p>
<p><strong>Vector类</strong></p>
<p>    Vector非常类似ArrayList，但是Vector是同步的。由Vector创建的Iterator，虽然和ArrayList创建的 Iterator是同一接口，但是，因为Vector是同步的，当一个Iterator被创建而且正在被使用，另一个线程改变了Vector的状态（例如，添加或删除了一些元素），这时调用Iterator的方法时将抛出ConcurrentModificationException，因此必须捕获该异常。</p>
<p> </p>
<p><strong>Stack 类</strong></p>
<p>    Stack继承自Vector，实现一个后进先出的堆栈。Stack提供5个额外的方法使得Vector得以被当作堆栈使用。基本的push和pop方 法，还有peek方法得到栈顶的元素，empty方法测试堆栈是否为空，search方法检测一个元素在堆栈中的位置。Stack刚创建后是空栈。</p>
<p> </p>
<p><strong>Set接口</strong></p>
<p>    Set继承自Collection接口。Set是一种不能包含有重复元素的集合，即对于满足e1.equals(e2)条件的e1与e2对象元素，不能同时存在于同一个Set集合里，换句话说，Set集合里任意两个元素e1和e2都满足e1.equals(e2)==false条件，Set最多有一个null元素。</p>
<p>     因为Set的这个制约，在使用Set集合的时候，应该注意：</p>
<p>    1，为Set集合里的元素的实现类实现一个有效的equals(Object)方法。</p>
<p>    2，对Set的构造函数，传入的Collection参数不能包含重复的元素。</p>
<p> </p>
<p>    请注意：必须小心操作可变对象（Mutable Object）。如果一个Set中的可变元素改变了自身状态导致Object.equals(Object)=true将导致一些问题。</p>
<p> </p>
<p><strong>HashSet类</strong></p>
<p>    此类实现 Set 接口，由哈希表（实际上是一个 HashMap 实例）支持。它不保证集合的迭代顺序；特别是它不保证该顺序恒久不变。此类允许使用 null 元素。</p>
<p>    HashSet不是同步的，需要用以下语句来进行S同步转换：<br />            Set s = Collections.synchronizedSet(new HashSet(...));<br /> </p>
<p><strong>Map接口</strong></p>
<p>    Map没有继承Collection接口。也就是说Map和Collection是2种不同的集合。Collection可以看作是（value）的集合，而Map可以看作是（key，value）的集合。</p>
<p>    Map接口由Map的内容提供3种类型的集合视图，一组key集合，一组value集合，或者一组key-value映射关系的集合。</p>
<p> </p>
<p><strong>Hashtable类</strong></p>
<p>    Hashtable继承Map接口，实现一个key-value映射的哈希表。任何非空（non-null）的对象都可作为key或者value。</p>
<p>    添加数据使用put(key, value)，取出数据使用get(key)，这两个基本操作的时间开销为常数。</p>
<p>Hashtable 通过initial capacity和load factor两个参数调整性能。通常缺省的load factor 0.75较好地实现了时间和空间的均衡。增大load factor可以节省空间但相应的查找时间将增大，这会影响像get和put这样的操作。</p>
<p>使用Hashtable的简单示例如下，将1，2，3放到Hashtable中，他们的key分别是”one”，”two”，”three”：</p>
<ol>
<li>Hashtable numbers = new Hashtable(); </li>
<li>numbers.put("one", new Integer(1)); </li>
<li>numbers.put("two", new Integer(2)); </li>
<li>numbers.put("three", new Integer(3)); </li>
</ol>
<p>要取出一个数，比如2，用相应的key：</p>
<ol>
<li>Integer n = (Integer)numbers.get("two"); </li>
<li>System.out.println("two =" + n); </li>
</ol>
<p>    由于作为key的对象将通过计算其散列函数来确定与之对应的value的位置，因此任何作为key的对象都必须实现hashCode和equals方 法。hashCode和equals方法继承自根类Object，如果你用自定义的类当作key的话，要相当小心，按照散列函数的定义，如果两个对象相 同，即obj1.equals(obj2)=true，则它们的hashCode必须相同，但如果两个对象不同，则它们的hashCode不一定不同，如 果两个不同对象的hashCode相同，这种现象称为冲突，冲突会导致操作哈希表的时间开销增大，所以尽量定义好的hashCode()方法，能加快哈希 表的操作。</p>
<p>    如果相同的对象有不同的hashCode，对哈希表的操作会出现意想不到的结果（期待的get方法返回null），要避免这种问题，只需要牢记一条：要同时复写equals方法和hashCode方法，而不要只写其中一个。</p>
<p>    Hashtable是同步的。</p>
<p> </p>
<p><strong>HashMap类</strong></p>
<p>    HashMap和Hashtable类似，不同之处在于HashMap是非同步的，并且允许null，即null value和null key。，但是将HashMap视为Collection时（values()方法可返回Collection），其迭代子操作时间开销和HashMap 的容量成比例。因此，如果迭代操作的性能相当重要的话，不要将HashMap的初始化容量设得过高，或者load factor过低。</p>
<p> </p>
<p><strong>WeakHashMap类</strong></p>
<p>    WeakHashMap是一种改进的HashMap，它对key实行“弱引用”，如果一个key不再被外部所引用，那么该key可以被GC回收。</p>
<p> </p>
<p><strong>对集合操作的工具类</strong></p>
<p>    Java提供了java.util.Collections，以及java.util.Arrays类简化对集合的操作<br />
<br />    java.util.Collections主要提供一些static方法用来操作或创建Collection，Map等集合。<br />
    java.util.Arrays主要提供static方法对数组进行操作。。</p>
<p> </p>
<p><strong>总结</strong></p>
<p>    如果涉及到堆栈，队列等操作，应该考虑用List，对于需要快速插入，删除元素，应该使用LinkedList，如果需要快速随机访问元素，应该使用ArrayList。</p>
<p>    如果程序在单线程环境中，或者访问仅仅在一个线程中进行，考虑非同步的类，其效率较高，如果多个线程可能同时操作一个类，应该使用同步的类。</p>
<p>    在除需要排序时使用TreeSet,TreeMap外,都应使用HashSet,HashMap,因为他们 的效率更高。</p>
<p>    要特别注意对哈希表的操作，作为key的对象要正确复写equals和hashCode方法。</p>
<p> </p>
<p>    容器类仅能持有对象引用（指向对象的指针），而不是将对象信息copy一份至数列某位置。一旦将对象置入容器内，便损失了该对象的型别信息。</p>
<p>    尽量返回接口而非实际的类型，如返回List而非ArrayList，这样如果以后需要将ArrayList换成LinkedList时，客户端代码不用改变。这就是针对抽象编程。</p>
<p> </p>
<p><strong>注意：</strong></p>
<p>1、Collection没有get()方法来取得某个元素。只能通过iterator()遍历元素。</p>
<p>2、Set和Collection拥有一模一样的接口。</p>
<p>3、List，可以通过get()方法来一次取出一个元素。使用数字来选择一堆对象中的一个，get(0)...。(add/get)</p>
<p>4、一般使用ArrayList。用LinkedList构造堆栈stack、队列queue。</p>
<p>5、Map用 put(k,v) / get(k)，还可以使用containsKey()/containsValue()来检查其中是否含有某个key/value。</p>
<p>      HashMap会利用对象的hashCode来快速找到key。</p>
<p> </p>
<p>6、Map中元素，可以将key序列、value序列单独抽取出来。</p>
<p>使用keySet()抽取key序列，将map中的所有keys生成一个Set。</p>
<p>使用values()抽取value序列，将map中的所有values生成一个Collection。</p>
<p>为什么一个生成Set，一个生成Collection？那是因为，key总是独一无二的，value允许重复。</p>
<p> </p>
<p>------------------------</p>
<p>本文结合了几篇网上文章并摘录而成的：</p>
<p>1. <a href="http://jonsion.javaeye.com/blog/421993" rel="external nofollow noreferrer">Java Collections Framework - Java集合框架List,Map,Set等全面介绍</a></p>
<p>2. <a href="http://blog.csdn.net/Fitzwilliam/archive/2006/02/10/596384.aspx" rel="external nofollow noreferrer">细说Java之util类</a></p>
<p>3. <a href="http://billy-lee.javaeye.com/blog/356398" rel="external nofollow noreferrer">Java基本概念：集合类 List/Set/Map... 的区别和联系</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 05:39:28</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%90%8c%e6%ad%a5/" title="同步">同步</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/%e5%ba%8f%e5%88%97/" title="序列">序列</a>, <a href="https://www.iamivan.net/tag/list/" title="list">list</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/arraylist/" title="arraylist">arraylist</a>, <a href="https://www.iamivan.net/tag/hashmap/" title="hashmap">hashmap</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java集合框架List，Map，Set等全面介绍的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7ZQZZp.html" rel="bookmark">java集合框架07&mdash;&mdash;Map架构与源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几节我们对Collection以及Collection中的List部分进行了分析,Collection中还有个Set,由于Set是基于Map实现的,所以这里我们先分析Map,后面章节再继续学习Set.首先我们看下Map架构图:         从图中可以看出:         1. Map是一个接口,Map中存储的内容是键值对(key-value).         2. 为了方便,我们抽象出AbstractMap类来让其他类继承,该类实现了Map中的大部分API,其他Map的具体实现就可以通			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDWmoBp.html" rel="bookmark">JAVA集合框架之Map接口实现类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java.util.HashMap&lt;K,V&gt; 基于哈希表的 Map 接口的实现.此实现提供所有可选的映射操作,并允许使用 null 值和 null 键.(除了非同步和允许使用 null 之外,HashMap 类与 Hashtable 大致相同.)此类不保证映射的顺序,特别是它不保证该顺序恒久不变. 此实现假定哈希函数将元素适当地分布在各桶之间,可为基本操作(get 和 put)提供稳定的性能.迭代 collection 视图所需的时间与 HashMap 实例的&quot;容量&quot;(桶的			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQ8Kzq.html" rel="bookmark">Java集合源码剖析：Java集合框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java集合工具包位于Java.util包下,包含了很多常用的数据结构,如数组.链表.栈.队列.集合.哈希表等.学习Java集合框架下大致可以分为如下五个部分:List列表.Set集合.Map映射.迭代器(Iterator.Enumeration).工具类(Arrays.Collections). Java集合类的整体框架如下: 从上图中可以看出,集合类主要分为两大类:Collection和Map. Collection是List.Set等集合高度抽象出来的接口,它包含了这些集合的基本操作,它主			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkqm6b.html" rel="bookmark">java &vert; 集合框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				集合框架 集合代表了一组对象,Java中的集合框架定义了一套规范,用来表示.操作集合,使具体操作与实现细节解耦. 而这些操作无非就是增.删.改.查! 集合和数组的区别: 1.数组的长度固定,集合长度可变. 2.数组只能存储相同类型的数据(基本类型/引用类型),集合可存储各种类型的数据. Java集合框架接口 Java集合框架的顶层接口包括: 一.Collection接口: 1.实现Collection接口的集合有List.Set.Queue(Java队列实现). 2.List:排列有序,可以有重			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA7GrKz.html" rel="bookmark">&lbrack;Java&rsqb; 集合框架的层次结构和使用规则梳理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Java语言中,Java语言的设计者对常用的数据结构和算法做了一些规范(接口)和实现(具体实现接口的类).所有抽象出来的数据结构和操作(算法)统称为Java集合框架(JavaCollectionFramework). Java程序员在具体应用时,不必考虑数据结构和算法实现细节,只需要用这些类创建出来一些对象,然后直接应用就可以了,这样就大大提高了编程效率. 概述 什么是框架?  类库的集合 什么是集合? 存放数据的容器 集合框架用来干什么? 用来表示和操作的统一的架构 集合框架包含了两部分:一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmQR8z.html" rel="bookmark">java基础-学到java集合框架中对那个复写equals的疑问，求解答</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 学到java集合框架中对那个复写equals的疑问,求解答 import java.util.*; class Student implements Comparable { private String name; private int age; Student(String name,int age) { this.name = name; this.age = age; } public int compareTo(Student s) { int num = new Inte			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJAq0qp.html" rel="bookmark">Java集合框架学习总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;Java集合框架学习总结&gt; 以下介绍经常使用的集合类,这里不介绍集合类的使用方法,只介绍每个集合类的用途和特点,然后通过比较相关集合类的不同特点来让我们更深入的了解它们.   Collection接口 1.Collection是最基本的集合接口,一个Collection代表一组Object,即Collection的元素(Elements). 2.所有实现Collection接口的类都必须提供两个标准的构造函数:1.无参数的构造函数用于创建一个空的Collection,2.Collection			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rnLgz.html" rel="bookmark">Java集合框架实现自定义排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java集合框架针对不同的数据结构提供了多种排序的方法,虽然很多时候我们可以自己实现排序,比如数组等,但是灵活的使用JDK提供的排序方法,可以提高开发效率,而且通常JDK的实现要比自己造的轮子性能更优化. 1.使用Arrays对数组进行排序 Java API对Arrays类的说明是:此类包含用来操作数组(比如排序和搜索)的各种方法. (1)使用Arrays排序 Arrays使用非常简单,直接调用sort()即可: 1 2 3 4 5 6 7 8 9 10 11 int[] arr = new i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bodRggM.html" rel="bookmark">Java集合框架：HashMap</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java集合框架概述   Java集合框架无论是在工作.学习.面试中都会经常涉及到,相信各位也并不陌生,其强大也不用多说,博主最近翻阅java集合框架的源码以及搜索一些相关资料整理出Java集合框架的系列.一方面是做一个总结,方便以后查阅,另一方面希望各位小伙伴能够提出不足之处,我会及时更新修改.   博主从网上抠了一张图,觉得画得还是比较形象的,给大家参考一下.   上述类图中,实线边框的是实现类,比如ArrayList,LinkedList,HashMap等,折线边框的是抽象类,比如Abst			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLWk8M.html" rel="bookmark" class="title">设计参考&colon;国外45个漂亮的企业网站设计实例</a>
					<div>
						纵观历史,伟大的设计者总是发现新的方法来展示他们的创意从而表达自己,对设计的定义更为关键的是在现在的条件下创造出一种新的和用户沟通的方式;没有&quot;好&quot;,&quot;坏&quot;的设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0JQ6z.html" rel="bookmark" class="title">酷Logo效果的制作</a>
					<div>
						Logo效果图:首先,新建一个88x31的的文件,这个应该不用说了吧.我们可以先分析一下这个LOGO的组成,首先是背景,然后文字的变色,最后是白色矩形的移动,那么我们可以分部来完成.背景:我这里的背景 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj75ZdM.html" rel="bookmark" class="title">浅谈Oracle控制文件多元化</a>
					<div>
						控制文件多元化:就是复制多个控制文件并存放到不同的磁盘. 1.使用SPFILE多元化控制文件 1)查看控制文件信息和spfile 信息 05:55:48 SQL&gt; select name fro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRP8Yz.html" rel="bookmark" class="title">PhotoShop绘制高光质感水晶网页按钮教程</a>
					<div>
						教程学习如何用Photoshop制作一款可以变换颜色的质感水晶按钮,主要用到了圆角矩形和图层样式,喜欢的朋友就一起来学习吧. 先看效果图. 新建文档500x300像素,背景黑色,新建图层,画一半径20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7kJXM.html" rel="bookmark" class="title">3大速成法则帮你轻松搞定极简主义网站</a>
					<div>
						  今天@念经的大猕猴桃 这篇译文特别不错,对于没有经验,想借鉴他人的设计师,如果没有强大的归纳能力,阅遍极简也枉然.恰好这篇文章把极简主义必备/抛弃的元素,可以运用的技巧,如何与其他风格结合这几个关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPG5PM.html" rel="bookmark" class="title">怎么设置路由器才不会被破解</a>
					<div>
						  明明带宽足够,家里的网速却越来越慢?你的无线网很有可能被盗用了!这不仅意味着网速和流量的损失,更有可能增加个人数据泄露的危险.戳图↓↓教你9招设置路由器,专治各种蹭网,让你家的网络更牢固!转发收藏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7a0Db.html" rel="bookmark" class="title">PPT加密演示文稿</a>
					<div>
						  如果不希望别人打开自己制作的Powerpoint演示文稿,可以通过设置打开密码来限制. 执行&quot;工具选项&quot;命令,打开&quot;选项&quot;对话框,切换到&quot;安全性& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNWd8M.html" rel="bookmark" class="title">Windows 7 系统视频捕捉时屏幕全黑</a>
					<div>
						  故障现象:在Windows 7系统下进行视频截图或捕捉时,发现播放时画面显示全黑. 解决处理:解决本地播放出现的视频变黑问题,一般有两个方法:一个是用两个不同的播放软件同时打开同一个文件;另一个方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Z7K4b.html" rel="bookmark" class="title">使用U盘安装系统出现白屏怎么办</a>
					<div>
						出于简单性和方便性,越来越多的用户选择用U盘来装系统,但方便的同时也给用户带来了新的麻烦,有些用户在用U盘装系统时,电脑突然出现了白屏的情况,这是什么原因导致的呢?下面让小编来为大家分析下并分享具体的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArBJAp.html" rel="bookmark" class="title">pdf文件如何转换成txt？</a>
					<div>
						  捷速pdf转换成txt转换器是一款绿色小巧.安全可靠的文字识别软件,它能有效帮助大家将pdf文件转换成txt,并且有效保证内容的完整.捷速pdf转换成txt转换器操作简单,用户只需几个步骤就可以完 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZBKNb.html" rel="bookmark" class="title">mstsc远程连接出错提示此计算机无法远程连接的解决方法</a>
					<div>
						  在使用远程桌面连接的时候发生了连接失败的问题,每次连接都会弹出&quot;两台计算机无法在分配的时间内连接&quot;的问题,在此之前连接远程桌面一直都没出问题,直到某天突然就弹出了这个错误无法连 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3B3AM.html" rel="bookmark" class="title">短网址遭暂停解析</a>
					<div>
						10月31日消息,今日有网友爆料称,TaoURL.coml从中午开始就无法打开,不知何故.对此,TaoURL创始人龙典发微博回应称,TaoURL无法打开是因为DNS解析出现了问题,随后龙典连续发布了几 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7xXAz.html" rel="bookmark" class="title">上百个常用搜索引擎免费登陆入口</a>
					<div>
						不能保证全部可用.一搜网站登录http://www.yisou.com/search_submit.html?source=yisou_www_hp百度免费登录入口  http://www.baidu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVmZOb.html" rel="bookmark" class="title">吴恩达的21节Deeplearning&period;ai课程学习经验总结</a>
					<div>
						截止到2017年10月25日,吴恩达在Coursera上目前有3门新的深度学习课程: 1.神经网络和深度学习(Neural Networks and Deep Learning) 2.改善深度神经网络 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWQx6p.html" rel="bookmark" class="title">Neither the JAVA&lowbar;HOME nor the JRE&lowbar;HOME environment variable is defined</a>
					<div>
						对于使用IDE开发的程序员来讲,并不是所有人都对自己用来吃饭的工具了如指掌.常在阴沟跑,哪能不翻船.为此我把自己使用Tomcat/Eclipse的一些经验教训整理了一下,会陆续的贴出来,也许会帮到和我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZrGAb.html" rel="bookmark" class="title">web2&period;0催生网络中产阶级</a>
					<div>
						一边是呼风唤雨的互联网精英,一边是1.23亿互联网草根,而web2.0则催生了互联网http://www.aliyun.com/zixun/aggregation/38084.html&quot;&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrxrOM.html" rel="bookmark" class="title">领域驱动设计系列（2）浅析VO、DTO、DO、PO的概念、区别和用处</a>
					<div>
						转自:http://kb.cnblogs.com/page/522348/ 上一篇文章作为一个引子,说明了领域驱动设计的优势,从本篇文章开始,笔者将会结合自己的实际经验,谈及领域驱动设计的应用.本篇文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A6GNz.html" rel="bookmark" class="title">ThinkPHP3&period;2 加载过程（二）</a>
					<div>
						原文:ThinkPHP3.2 加载过程(二) 回顾: 上次介绍了 ThinkPHP 的 Index.PHP入口文件.但只是TP的入口前面的入口(刷boss总是要过好几关才能让你看到 ,不然boss都没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeyDWb.html" rel="bookmark" class="title">关于Java异常和错误的几个问题</a>
					<div>
						1.Java中什么是Exception? 在java中,异常功能是通过实现比如Throwable,Exception,RuntimeException之类的类,然后还有一些处理异常时候的关键字,比如t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRmr3p.html" rel="bookmark" class="title">Java LinkedList基本用法</a>
					<div>
						LinkedList类是双向列表,列表中的每个节点都包含了对前一个和后一个元素的引用.LinkedList的构造函数如下1. public LinkedList():  --生成空的链表2. publ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1Vx4z.html" rel="bookmark" class="title">IT江湖三宗罪：利用垄断打压对手窥探用户隐私</a>
					<div>
						近日在国内吵得轰轰烈烈的&quot;3Q大战&quot;,从360指责QQ聊天软件偷窥用户隐私数据开始,到腾讯利用自己的用户优势宣布在装有360软件的机器上停止运行 QQ,事件发展到高潮,两家企业在较 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmg0Vb.html" rel="bookmark" class="title">政府、企业看过来：品牌危机管理的WEB2&period;0思考（二）</a>
					<div>
						2.1 品牌危机的含义 &amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp; 品牌危机是指在920.html&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94w2kb.html" rel="bookmark" class="title">Tomcat远程调试和加入JMS（转）</a>
					<div>
						  1.Tomcat 加入远程调试,在catalina.bat : SET CATALINA_OPTS=-server -Xdebug -Xnoagent -Djava.compiler=NONE - ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z1d7z.html" rel="bookmark" class="title">运筹学最小费用最大流，MATLAB编程</a>
					<div>
						问题描述 运筹学最小费用最大流,MATLAB编程 汽车生产 Fordco公司在底特律和达拉斯生产汽车.底特律的工厂最多可以生产6500辆汽车,达拉斯的工厂最多可以生产6000辆汽车.生产一辆汽车的成本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyegGJM.html" rel="bookmark" class="title">C&num;百度对象存储开发&comma;签名算法怎么实现</a>
					<div>
						问题描述 http://bce.baidu.com/doc/BOS/AuthenticationMechanism.html#.E7.AD.BE.E5.90.8D.E7.AE.97.E6.B3.95. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwNYmM.html" rel="bookmark" class="title">《VMware Virtual SAN权威指南》一3&period;5　可能发生的网络配置问题</a>
					<div>
						3.5 可能发生的网络配置问题 如果VSAN VMkernel没能配置正确,在VSAN群集对象的Monitor(监控)页面上的Virtual SAN→Health(运行状况)部分会显示一条配置警告消息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjoAKM.html" rel="bookmark" class="title">c&plus;&plus;-cocos2d基础游戏源代码</a>
					<div>
						问题描述 cocos2d基础游戏源代码 老师期末作业,想做猜cocos2d猜数字游戏,就要最简单的,有没有大神可以给我分享 解决方案 使用Cocos2d的从零基础开始你的游戏生涯(系列之一 基础简单O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnay0M.html" rel="bookmark" class="title">windows 版Tomcat 7&period;0的配置</a>
					<div>
						http://hi.baidu.com/liguohei/item/d6ea23ff904f98753d198b24 测试成功,截图 ~~~~~~~~~~~~~~~ 一.安装JDK 1.7     1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkEOrp.html" rel="bookmark" class="title">基于Bootstrap实现Material Design风格表单插件 附源码下载&lowbar;javascript技巧</a>
					<div>
						Jquery Material Form Plugin是一款基于Bootstrap的Material Design风格的jQuery表单插件.该表单通过自定义样式和jQuery来将Bootstrap的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QKJrM.html" rel="bookmark" class="title">哪个帮忙在javaeye上面上传个有道词典</a>
					<div>
						问题描述 没有词霸,程序一报错就看不懂了,公司什么下载网站都禁了,好像只有javaeye上面的东西能下载下来,希望各位帮个忙,上传后把地址告诉我,感激不尽!! 解决方案 http://ethen.it ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
